'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-fed40845.js');

const quickomChatQrcodeCss = "/*! normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css */html{line-height:1.15;-webkit-text-size-adjust:100%;}body{margin:0}button{font-family:inherit;font-size:100%;line-height:1.15;margin:0;}button{overflow:visible}button{text-transform:none}button,[type=\"button\"]{-webkit-appearance:button}button::-moz-focus-inner,[type=\"button\"]::-moz-focus-inner{border-style:none;padding:0}button:-moz-focusring,[type=\"button\"]:-moz-focusring{outline:1px dotted ButtonText}[type=\"number\"]::-webkit-inner-spin-button,[type=\"number\"]::-webkit-outer-spin-button{height:auto}[hidden]{display:none}p{margin:0}button{background-color:transparent;background-image:none}button:focus{outline:1px dotted;outline:5px auto -webkit-focus-ring-color}html{font-family:system-ui, -apple-system, BlinkMacSystemFont, \"Segoe UI\", Roboto, \"Helvetica Neue\", Arial, \"Noto Sans\", sans-serif, \"Apple Color Emoji\", \"Segoe UI Emoji\", \"Segoe UI Symbol\", \"Noto Color Emoji\";line-height:1.5;}*,::before,::after{-webkit-box-sizing:border-box;box-sizing:border-box;border-width:0;border-style:solid;border-color:#e2e8f0;}button{cursor:pointer}button{padding:0;line-height:inherit;color:inherit}svg,iframe{display:block;vertical-align:middle}.rounded-full{border-radius:9999px}.inline-flex{display:-ms-inline-flexbox;display:inline-flex}.hidden{display:none}.items-center{-ms-flex-align:center;align-items:center}.justify-center{-ms-flex-pack:center;justify-content:center}.h-screen{height:100vh}.mt-2{margin-top:0.5rem}.focus\\:outline-none:focus{outline:0}.absolute{position:absolute}.relative{position:relative}.shadow{-webkit-box-shadow:0 1px 3px 0 rgba(0, 0, 0, 0.1), 0 1px 2px 0 rgba(0, 0, 0, 0.06);box-shadow:0 1px 3px 0 rgba(0, 0, 0, 0.1), 0 1px 2px 0 rgba(0, 0, 0, 0.06)}.text-right{text-align:right}.text-white{--text-opacity:1;color:#fff;color:rgba(255, 255, 255, var(--text-opacity))}.visible{visibility:visible}.w-screen{width:100vw}@-webkit-keyframes spin{to{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes spin{to{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@-webkit-keyframes ping{75%,100%{-webkit-transform:scale(2);transform:scale(2);opacity:0}}@keyframes ping{75%,100%{-webkit-transform:scale(2);transform:scale(2);opacity:0}}@-webkit-keyframes pulse{50%{opacity:.5}}@keyframes pulse{50%{opacity:.5}}@-webkit-keyframes bounce{0%,100%{-webkit-transform:translateY(-25%);transform:translateY(-25%);-webkit-animation-timing-function:cubic-bezier(0.8,0,1,1);animation-timing-function:cubic-bezier(0.8,0,1,1)}50%{-webkit-transform:none;transform:none;-webkit-animation-timing-function:cubic-bezier(0,0,0.2,1);animation-timing-function:cubic-bezier(0,0,0.2,1)}}@keyframes bounce{0%,100%{-webkit-transform:translateY(-25%);transform:translateY(-25%);-webkit-animation-timing-function:cubic-bezier(0.8,0,1,1);animation-timing-function:cubic-bezier(0.8,0,1,1)}50%{-webkit-transform:none;transform:none;-webkit-animation-timing-function:cubic-bezier(0,0,0.2,1);animation-timing-function:cubic-bezier(0,0,0.2,1)}}@media (min-width: 640px){.sm\\:block{display:block}.sm\\:h-auto{height:auto}.sm\\:absolute{position:absolute}.sm\\:w-auto{width:auto}}.bubble{width:60px;height:60px;background-color:var(--chat-head-bg-color,#176dfa);color:#fff;border:1px solid var(--chat-head-bg-color,#176dfa)}.bubble:hover{background-color:#fff;color:var(--chat-head-bg-color,#176dfa)}@media only screen and (min-width:640px){.chat-box-container{width:359px;height:505px}}";

const QuickomChatQrCode = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.backgroundColor = '#176DFA';
    this.domain = 'https://quickom-demo.web.app';
    this.isOpen = false;
    this.iframeElement = null;
  }
  toggleButton() {
    this.isOpen = !this.isOpen;
    this.sendMsgToIframe({
      resource: 'chat-box',
      method: this.isOpen ? 'show' : 'hide',
    });
  }
  sendMsgToIframe(msg) {
    this.iframeElement.contentWindow.postMessage(JSON.stringify(msg), this.domain);
  }
  componentWillLoad() {
    this.listenIframeMessage();
  }
  disconnectedCallback() {
    window.removeEventListener('message', this.onMessage);
  }
  getUrl() {
    return `${this.domain}/call/${this.alias}?k=chat-widget`;
  }
  listenIframeMessage() {
    let onMessage = event => {
      if (event.origin !== this.domain) {
        return;
      }
      let data = JSON.parse(event.data);
      switch (data.resource) {
        case 'chat-box':
          this.onChatBoxMessage(data);
          break;
      }
    };
    window.addEventListener('message', onMessage, false);
    this.onMessage = onMessage;
  }
  onChatBoxMessage(data) {
    switch (data.method) {
      case 'show':
        this.isOpen = true;
        break;
      case 'hide':
        this.isOpen = false;
        break;
    }
  }
  render() {
    return (index.h("div", { class: {
        'sm:absolute': this.isOpen,
        'absolute': !this.isOpen,
      }, style: {
        bottom: 'var(--widget-position-bottom, initial)',
        right: 'var(--widget-position-right, initial)',
        top: 'var(--widget-position-top, initial)',
        left: 'var(--widget-position-left, initial)',
      } }, index.h("div", { class: "relative", style: { '--chat-head-bg-color': this.backgroundColor } }, index.h("div", { class: {
        'chat-box-container w-screen h-screen sm:w-auto sm:h-auto': true,
        'hidden': !this.isOpen,
      } }, index.h("iframe", { ref: el => (this.iframeElement = el), src: this.getUrl(), width: "100%", height: "100%", frameborder: "0" })), index.h("div", { class: { 'text-right': true, 'hidden sm:block mt-2': this.isOpen } }, index.h("button", { class: "bubble rounded-full inline-flex items-center text-white justify-center shadow focus:outline-none", onClick: () => this.toggleButton() }, index.h("svg-render", { src: index.getAssetPath(`./assets/speech-bubble.svg`) }))))));
  }
  static get assetsDirs() { return ["assets"]; }
};
QuickomChatQrCode.style = quickomChatQrcodeCss;

exports.quickom_chat_qrcode = QuickomChatQrCode;
