import { Component, h, Prop, State, getAssetPath } from '@stencil/core';
export class QuickomChat {
  constructor() {
    this.domain = 'https://quickom-demo.web.app';
    this.backgroundColor = '#176DFA';
    this.chatAccount = null;
    this.chatWithAccount = null;
    this.isOpen = false;
    this.isOpenned = false;
  }
  toggleButton() {
    this.isOpen = !this.isOpen;
  }
  onVisible(ev) {
    this.isOpen = ev.detail;
  }
  render() {
    this.isOpenned = this.isOpenned || this.isOpen;
    return (h("div", { class: {
        'sm:absolute': this.isOpen,
        'absolute': !this.isOpen,
      }, style: {
        bottom: 'var(--widget-position-bottom, initial)',
        right: 'var(--widget-position-right, initial)',
        top: 'var(--widget-position-top, initial)',
        left: 'var(--widget-position-left, initial)',
      } },
      h("div", { class: "relative", style: { '--chat-head-bg-color': this.backgroundColor } },
        this.isOpenned ? h("div", { class: {
            'w-screen h-screen sm:w-auto sm:h-auto chat-box-container': true,
            'hidden': !this.isOpen,
          } },
          h("quickom-chat-iframe", { domain: this.domain, chatAccount: this.chatAccount, chatWithAccount: this.chatWithAccount, onVisible: ev => this.onVisible(ev) })) : '',
        h("div", { class: { 'text-right': true, 'hidden sm:block mt-2': this.isOpen } },
          h("button", { class: "bubble rounded-full inline-flex items-center text-white justify-center shadow focus:outline-none", onClick: () => this.toggleButton() },
            h("svg-render", { src: getAssetPath(`./assets/speech-bubble.svg`) }))))));
  }
  static get is() { return "quickom-chat"; }
  static get originalStyleUrls() { return {
    "$": ["quickom-chat.styl"]
  }; }
  static get styleUrls() { return {
    "$": ["quickom-chat.css"]
  }; }
  static get properties() { return {
    "domain": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "domain",
      "reflect": false,
      "defaultValue": "'https://quickom-demo.web.app'"
    },
    "backgroundColor": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "background-color",
      "reflect": false,
      "defaultValue": "'#176DFA'"
    },
    "chatAccount": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "ChatAccount",
        "resolved": "ChatAccount",
        "references": {
          "ChatAccount": {
            "location": "import",
            "path": "../../dtos/chatAccount"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "defaultValue": "null"
    },
    "chatWithAccount": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "ChatWithAccount",
        "resolved": "ChatWithAccount",
        "references": {
          "ChatWithAccount": {
            "location": "import",
            "path": "../../dtos/chatWithAccount"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "defaultValue": "null"
    }
  }; }
  static get states() { return {
    "isOpen": {}
  }; }
}
